/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: ControlFlowLazyProxy.java,v 4d5dd3d15c6e 2010/06/09 00:47:02 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.android.ui;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import android.app.Activity;
import android.content.Intent;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
class ControlFlowLazyProxy extends ControlFlow
  {
    @CheckForNull
    private ControlFlow delegate;

    public ControlFlowLazyProxy (final @Nonnull Activity Activity)
      {
        this.activity = Activity;
      }

    @Override
    public void toNextStep (final @Nonnull Intent intent, final @Nonnull Object ... args)
      {
        getDelegate().toNextStep(intent, args);
      }

    @Override
    public void toNextStep (final @Nonnull Object... args)
      {
        getDelegate().toNextStep(args);
      }

    @Override
    public int getRequestCode()
      {
        return getDelegate().getRequestCode();
      }

    @Override @Nonnull
    public Class<? extends Activity> getInitialActivity()
      {
        return getDelegate().getInitialActivity();
      }

    @Nonnull
    private synchronized ControlFlow getDelegate()
      {
        if (delegate == null)
          {
            delegate = ControlFlow.forActivity2(activity);
          }

        return delegate;
      }
  }
